# Copyright (C) 2013-2015 Samuel Damashek, Peter Foley, James Forcier, Srijay Kasturi, Reed Koser, Christopher Reffett, and Fox Wilson
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

import re
from requests import post, get
from ..helpers.command import Command


def get_token(client_id, secret):
    postdata = {'grant_type': 'client_credentials', 'client_id': client_id, 'client_secret': secret, 'scope': 'http://api.microsofttranslator.com'}
    data = post('https://datamarket.accesscontrol.windows.net/v2/OAuth2-13', data=postdata).json()
    return data['access_token']


@Command(['translate', 'trans'], ['config'])
def cmd(send, msg, args):
    """Translate something.
    Syntax: {command} <text>
    """
    if not msg:
        send("Translate what?")
        return
    token = get_token(args['config']['api']['translateid'], args['config']['api']['translatesecret'])
    params = {'text': msg, 'to': 'en'}
    headers = {'Authorization': 'Bearer %s' % token}
    data = get('http://api.microsofttranslator.com/V2/Http.svc/Translate', params=params, headers=headers).text
    send(re.search('>(.*)<', data).group(1))
